package dev.banking.model;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class BankAccount {

    private final int accountId;
    private long balance;
    private Lock lock = new ReentrantLock();

    /*
     * Students may introduce additional fields
     * such as:
     * - Lock / ReentrantLock
     * - ReadWriteLock
     * - Object monitor
     * - etc.
     */

    public BankAccount(int accountId, long initialBalance) {
        this.accountId = accountId;
        this.balance = initialBalance;
    }

    public int getAccountId() {
        return accountId;
    }

    /* Return the current balance in a thread-safe way.
     *
     * Requirements:
     * - Must be safe under concurrent reads/writes
     * - Should not block unnecessarily if using read/write locks
     */
    public long getBalance() {

        lock.lock();
        try{
            return balance;
        }
        finally {
            lock.unlock();
        }
    }

    /* Increase balance atomically.
     *
     * Requirements:
     * - Must not lose updates under concurrency
     */
    public synchronized void deposit(long amount) {
        balance += amount;
    }

    /* Decrease balance atomically.
     *
     * Requirements:
     * - Must not cause race conditions
     * - Negative balance handling is NOT required unless you decide
     *   to extend the system (optional)
     */
    public synchronized void withdraw(long amount) {
        balance -= amount;
    }

    /*
     * Transfer money between two accounts atomically.
     *
     * IMPORTANT REQUIREMENTS:
     * - Must be atomic (no partial transfer)
     * - Must be deadlock-free
     * - Must protect both source and target accounts
     *
     * HINT:
     * - Consider global lock ordering using accountId
     * - Or tryLock with retry strategy
     */
    public void transfer(BankAccount target, long amount) {

        BankAccount first, second;

        if(target == this) return;

        if (this.getAccountId() < target.getAccountId()) {
            first = this;
            second = target;
        }
        else {
            first = target;
            second = this;
        }

        first.lock.lock();
        try {
            second.lock.lock();
            try {
                this.withdraw(amount);
                target.deposit(amount);
            }
            finally {
                second.lock.unlock();
            }
        }
        finally {
            first.lock.unlock();
        }
    }
}